my $cdrdbhost = $main::pluginconfig{'cdrdatabase'}{'database_host'}{''};
my $cdrdbname = $main::pluginconfig{'cdrdatabase'}{'database_name'}{''};
my $cdrdbuser = $main::pluginconfig{'cdrdatabase'}{'database_user'}{''};
my $cdrdbpass = $main::pluginconfig{'cdrdatabase'}{'database_password'}{''};

my $cdr_db_connected = 0;
my $dbhcdr;

cdr_connect_db();

$AMI_Event_Handler{'cdrdatabase'}{'CDR'} = sub {

    my $event = shift;
    my @allreturn;

    my $query = "INSERT INTO cdr (calldate,clid,src,dst,dcontext,channel,dstchannel,lastapp,lastdata,duration,billsec,disposition,amaflags,accountcode,uniqueid,userfield) ";
    $query   .= "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";

    my @values = ( ${$event}{'StartTime'}, 
                   ${$event}{'CallerID'}, 
                   ${$event}{'Source'}, 
                   ${$event}{'Destination'}, 
                   ${$event}{'DestinationContext'}, 
                   ${$event}{'Channel'}, 
                   ${$event}{'DestinationChannel'}, 
                   ${$event}{'LastApplication'}, 
                   ${$event}{'LastData'}, 
                   ${$event}{'Duration'}, 
                   ${$event}{'BillableSeconds'}, 
                   ${$event}{'Disposition'}, 
                   ${$event}{'AMAFlags'}, 
                   ${$event}{'AccountCode'}, 
                   ${$event}{'UniqueID'}, 
                   ${$event}{'UserField'}
                );

    if($cdr_db_connected==1) {
        my $rv = $dbhcdr->exec($query,@values, sub {} );
    }
    return @allreturn;

};

sub cdr_connect_db() { 

    $dbhcdr = new AnyEvent::DBI "DBI:mysql:$cdrdbname;host=$cdrdbhost", $cdrdbuser, $cdrdbpass, 
    on_connect => sub { 
        my $dbb = shift; 
        my $success = shift; 
        if ($success == 1) { 
            $cdr_db_connected = 1; 
        }  
    }, 
    on_error => sub { 
       if ( $@ =~ m/gone away/ ) { 
           $cdr_db_connected = 0; 
       } 
       print "error $@ at $_[1]:$_[2]\n"; 
    }; 

} 

